package simulation

import (
	"math/rand"

	sdk "git.cw.tr/mukan-network/mukan-sdk/types"
	"git.cw.tr/mukan-network/mukan-sdk/types/address"
	simtypes "git.cw.tr/mukan-network/mukan-sdk/types/simulation"
	"git.cw.tr/mukan-network/mukan-sdk/x/simulation"

	"github.com/cosmos/ibc-go/modules/light-clients/08-wasm/v10/types"
)

// Simulation operation weights constants
const (
	DefaultWeightMsgStoreCode int = 100

	OpWeightMsgStoreCode = "op_weight_msg_store_code" // #nosec
)

// ProposalMsgs defines the module weighted proposals' contents
func ProposalMsgs() []simtypes.WeightedProposalMsg {
	return []simtypes.WeightedProposalMsg{
		simulation.NewWeightedProposalMsg(
			OpWeightMsgStoreCode,
			DefaultWeightMsgStoreCode,
			SimulateMsgStoreCode,
		),
	}
}

// SimulateMsgStoreCode returns a random MsgStoreCode for the 08-wasm module
func SimulateMsgStoreCode(r *rand.Rand, _ sdk.Context, _ []simtypes.Account) sdk.Msg {
	var signer sdk.AccAddress = address.Module("gov")

	return &types.MsgStoreCode{
		Signer:       signer.String(),
		WasmByteCode: []byte{0x01},
	}
}
